package service

import (
	"git.pbiernat.dev/egommerce/go-api-pkg/fluentd"
	amqp "git.pbiernat.dev/egommerce/go-api-pkg/rabbitmq"
	"git.pbiernat.dev/egommerce/order-service/internal/app/event"
	base "github.com/streadway/amqp"
)

type OrderService struct {
	ebCh *base.Channel
	log  *fluentd.Logger
}

func NewOrderService(chn *base.Channel, log *fluentd.Logger) *OrderService {
	return &OrderService{chn, log}
}

func (s *OrderService) UpdateOrderStatus(reqID, orderID, status string) (string, error) {
	s.log.Log("Update order#%s status to %s", orderID, status)

	msg := &event.StatusUpdateEvent{Event: event.NewEvent(reqID), OrderID: orderID, Status: status}
	amqp.Publish(s.ebCh, "api-events", "order.email.statusUpdate", msg)
	amqp.Publish(s.ebCh, "api-events", "order.warehouse.orderFinalized", msg) // test event...

	return orderID, nil
}
